/*
 *
 *  ߥˡåϥɥ
 *
 *  Copyright 1994-1997 By A.Takuma
 *
 *  System      : Mini Message Handler
 *  Sub system  : MMH install command
 *  File        : inst_mmh.c
 *  Version     : 2.19
 *  First Edit  : 1994-08/15
 *  Last  Edit  : 1997-12/15
 *  Author      :  
 *
 */

#include	"compat.h"
#include	"mmh.h"

char	mh_path[PATH_BUFF];		/* ᡼ѥ		*/
struct option	option[] = {		/* ץ		*/
  {"help",	0},
  {"auto",	0},
};

/*
 * ᥤؿ
 */

int	main(argc, argv)
     int	argc;
     char	*argv[];
{
  struct stat	stat_buff;
  FILE		*fp;
  int		status;
  int		i, j;
  int		a_flag = 0;
  char		buff1[PATH_BUFF];
#ifdef	MH_INIT_FILE2
  char		buff2[PATH_BUFF];
#endif	/* MH_INIT_FILE2 */
  char		*ptr;

  ptr = separater(argv[0]);
  if (ptr != (char*)NULL) {
    strcpy(prog_name, ptr + 1);
  } else {
    strcpy(prog_name, argv[0]);
  }

  ptr = (char*)getenv(HOME_ENV);

  if (ptr != (char*)NULL) {
    strcpy(home_dir, ptr);
#ifdef	X68K
    _addlastsep(home_dir);
#else	/* !X68K */
    strcat(home_dir, "/");
#endif	/* !X68K */
  } else {
    print_fatal("Warning : Can't get home directory.");
    strcpy(home_dir, "./");
  }

  /*
   * åβ
   */

  for (i = 1; i < argc; i++) {
    ptr = argv[i];
    if ((*ptr == '-') || (*ptr == '/')) {
      ptr++;
      for (j = 0; j < (sizeof(option) / sizeof(struct option)); j++) {
	if (!strncmp(option[j].name, ptr, strlen(option[j].name))) {
	  switch (j) {
	  case 0:	/* -help	*/
	    usage(prog_name, "[switches]",
		  option, sizeof(option) / sizeof(struct option));
	    exit(0);
	    break;
	  case 1:	/* -auto	*/
	    a_flag = 1;
	    break;
	  default:
	    break;
	  }
	  j = -1;
	  break;
	}
      }
      if (j >= 0) {
	print_fatal("Bad option.");
	exit(1);
      }
    } else {
      print_fatal("Bad option.");
      exit(1);
    }
  }
  status = 0;
  sprintf(buff1, "%s%s", home_dir, MH_INIT_FILE);
  if (!stat(buff1, &stat_buff)) {
    status = 1;
  }
#ifdef	MH_INIT_FILE2
  sprintf(buff2, "%s%s", home_dir, MH_INIT_FILE2);
  if (!stat(buff2, &stat_buff)) {
    status = 1;
  }
#endif	/* MH_INIT_FILE2 */
  if (status) {
    print_fatal("MMH already installed.");
    exit(1);
  }
  fp = fopen(buff1, "w");
  if (fp != (FILE*)NULL) {
    chmod(buff1, S_IREAD | S_IWRITE);
#ifdef	MH_INIT_FILE2
  } else {
    fp = fopen(buff2, "w");
    if (fp != (FILE*)NULL) {
      chmod(buff2, S_IREAD | S_IWRITE);
    } else {
      print_fatal("Can't create MMH profile.");
      exit(1);
    }
#endif	/* MH_INIT_FILE2 */
  }
  fprintf(fp, "Path: Mail\n");
  fclose(fp);
  sprintf(mh_path, "%s%s", home_dir, MH_DEFAULT_PATH);
  if (mkdir(mh_path, S_IEXEC | S_IWRITE | S_IREAD)) {
    print_fatal("Can't create MMH path.");
    status = 1;
  } else {
    chmod(mh_path, S_IEXEC | S_IREAD | S_IWRITE);
  }
  sprintf(buff1, "%s/%s", mh_path, MH_DEFAULT_FOLDER);
  if (mkdir(buff1, S_IEXEC | S_IWRITE | S_IREAD)) {
    print_fatal("Can't create default folder.");
    status = 1;
  } else {
    sprintf(buff1, "%s/%s", mh_path, MH_CONTEXT_FILE);
    fp = fopen(buff1, "w");
    if (fp != (FILE*)NULL) {
      chmod(buff1, S_IREAD | S_IWRITE);
      fprintf(fp, "%s %s\n", MH_CONTEXT_FIELD, MH_DEFAULT_FOLDER);
      fclose(fp);
    } else {
      print_fatal("Can't create context file.");
      status = 1;
    }
  }
  exit(status);
}
