/*
 *
 *  ߥˡåϥɥ
 *
 *  Copyright 1994-1997 By A.Takuma
 *
 *  System      : Mini Message Handler
 *  Sub system  : Mark message command
 *  File        : mark.c
 *  Version     : 2.19
 *  First Edit  : 1994-10/04
 *  Last  Edit  : 1997-12/15
 *  Author      :  
 *
 */

#include	"compat.h"
#include	"mmh.h"

char	mh_path[PATH_BUFF];		/* ᡼ѥ		*/
struct option	option[] = {		/* ץ		*/
  {"help",		0},
  {"add",		0},
  {"delete",		0},
  {"list",		0},
  {"sequence",		SEQUENCE_MASK},
  {"zero",		0},
  {"nozero",		0},
};
static char		mark_opt[SMALL_BUFF];
static struct cpy_hdr	mark_option[] = {
  {MH_PATH_FIELD,	mh_path,	sizeof(mh_path)},
  {"markopt:",		mark_opt,	sizeof(mark_opt)},
};

static int	mark_message();	/* å	*/

/*
 * ᥤؿ
 */

int	main(argc, argv)
     int	argc;
     char	*argv[];
{
  int		status;
  int		current;
  int		i, j;
  int		a_flag = 0;
  int		t_flag = 0;
  int		z_flag = 0;
  char		*ptr, *ptr2;

  ptr = separater(argv[0]);
  if (ptr != (char*)NULL) {
    strcpy(prog_name, ptr + 1);
  } else {
    strcpy(prog_name, argv[0]);
  }
  /*
   * ե졼
   */

  if (get_environ(mark_option, sizeof(mark_option) / sizeof(struct cpy_hdr))) {
    print_fatal("Configuration error.");
    exit(1);
  }

  /*
   * åβ
   */

  ptr2 = mark_opt;
  for (i = 0; i < argc; i++) {
    if (i) {
      ptr = argv[i];
    } else {
      ptr = get_opt_param(&ptr2);
      if (*ptr2) {
	i--;
      }
    }
    if (*ptr == '+') {
      ptr++;
      if (*ptr) {
	strcpy(target_folder, ptr);
	t_flag = 1;
      } else {
	print_fatal("Folder does not specified.");
	exit(1);
      }
    } else if ((*ptr == '-') || (*ptr == '/')) {
      ptr++;
      for (j = 0; j < (sizeof(option) / sizeof(struct option)); j++) {
	if (!strncmp(option[j].name, ptr, strlen(option[j].name))) {
	  switch (j) {
	  case 0:	/* -help	*/
	    usage(prog_name, "[+folder] [msg] [switches]",
		  option, sizeof(option) / sizeof(struct option));
	    exit(0);
	    break;
	  case 1:	/* -add		*/
	    a_flag = 1;
	    break;
	  case 2:	/* -delete	*/
	    a_flag = -1;
	    break;
	  case 3:	/* -list	*/
	    a_flag = 0;
	    break;
	  case 4:	/* -sequence	*/
	    ptr = (char*)NULL;
	    if (i > 0) {
	      if (++i < argc) {
		ptr = argv[i];
	      }
	    } else if (*ptr2) {
	      ptr = get_opt_param(&ptr2);
	    }
	    if (ptr != (char*)NULL) {
	    } else {
	      print_fatal("Sequence does not specified.");
	      exit(1);
	    }
	    break;
	  case 5:	/* -zero	*/
	    z_flag = 1;
	    break;
	  case 6:	/* -nozero	*/
	    z_flag = 0;
	    break;
	  default:
	    break;
	  }
	  j = -1;
	  break;
	}
      }
      if (j >= 0) {
	print_fatal("Bad option.");
	exit(1);
      }
    }
  }
  get_message(target_folder);
  current = get_current(target_folder);
  for (i = 1; i < argc; i++) {
    ptr = argv[i];
    if ((*ptr != '+') && (*ptr != '-') && (*ptr != '/')) {
      if (add_list(ptr, current)) {
	exit(1);
      }
    }
  }
  if (check_folder(target_folder)) {
    print_fatal("Folder %s does not exist.", target_folder);
    exit(1);
  }
  status = 0;
  if (!target_number) {
    if (current <= 0) {
      print_fatal("Can't get current message.");
      exit(1);
    }
    if (add_list(MH_CUR_PARAM, current)) {
      exit(1);
    }
  }
  if (!target_number) {
    print_fatal("Unexpected system error.");
    exit(1);
  }
  qsort(target_ptr, target_number, sizeof(int), int_compare);
  for (i = 0; i < target_number; i++) {
    if (mark_message(target_folder, target_ptr[i], a_flag)) {
      status = 1;
    }
  }
  if (t_flag) {
    set_context(target_folder, folder_stack);
  }
  exit(status);
}

/*
 * åޡ
 */

static int	mark_message(folder_name, number, a_flag)
     char	*folder_name;
     int	number;
     int	a_flag;
{
  int	status;

  status = 0;
  return(status);
}
